$	on warning then goto ERROR_HANDLER
$	on control_y then goto ERROR_HANDLER
$!
$	set symbol/scope=(noglobal,nolocal)
$!
$	v_phases = " ALL CONFIG VERSION MAIN CPU FPU GUI IODEV MEMORY LINK "
$	v_options = " DEBUG PICKUP "
$!
$	gosub SETUP
$!
$	comp = "call compile"
$	include_dir = "[],[.instrument.stubs]"
$!
$	gosub DO_'P1'
$!
$!
$END:
$	exit
$!------------------------------------------------------------------------------
$DO_ALL:
$	gosub DO_CONFIG
$	gosub DO_VERSION
$	gosub DO_MAIN
$	gosub DO_CPU
$	gosub DO_FPU
$	gosub DO_GUI
$	gosub DO_IODEV
$	gosub DO_MEMORY
$	gosub DO_LINK
$return
$!------------------------------------------------------------------------------
$DO_CONFIG:
$	msg "Making CONFIG.H"
$	if f$search("config.h") .nes. ""
$	  then	msg " (exists)"
$		return
$	endif
$	define/user sys$output nla0:
$	edit/edt/command=sys$input config.h_in /output=config.h
!
! Configure options
! -----------------
!
s/#define BX_USE_CONTROL_PANEL 1/#define BX_USE_CONTROL_PANEL 0/w
s/#define BX_CPU_LEVEL 0/#define BX_CPU_LEVEL 5/w
s/#define BX_WITH_X11 0/#define BX_WITH_X11 1/w
s/#define BX_SUPPORT_FPU 0/#define BX_SUPPORT_FPU 1/w
s/#define BX_SUPPORT_CDROM 0/#define BX_SUPPORT_CDROM 1/w
!
! You need this to be able to set IPS value in .bochsrc
!
!s/#define BX_SHOW_IPS         0/#define BX_SHOW_IPS         1/w
!
! Stuff that configure should find out
! ------------------------------------
!
!  There are more otrions than listed here, if the default is okay it's not
!  listed, this is bound to be a mistake in later ports ...
!
! 1.2.1
!
s/#define SIZEOF_UNSIGNED_CHAR      0/#define SIZEOF_UNSIGNED_CHAR      1/w
s/#define SIZEOF_UNSIGNED_SHORT     0/#define SIZEOF_UNSIGNED_SHORT     2/w
s/#define SIZEOF_UNSIGNED_INT       0/#define SIZEOF_UNSIGNED_INT       4/w
s/#define SIZEOF_UNSIGNED_LONG      0/#define SIZEOF_UNSIGNED_LONG      4/w
s/#define SIZEOF_UNSIGNED_LONG_LONG 0/#define SIZEOF_UNSIGNED_LONG_LONG 8/w
s/#define SIZEOF_INT_P              0/#define SIZEOF_INT_P              4/w
s/#define BX_HAVE_STRTOULL 0/#define BX_HAVE_STRTOULL 1/w
s/#define BX_HAVE_STRTOUQ 0/#define BX_HAVE_STRTOUQ 1/w
s/#define BX_HAVE_STRDUP 0/#define BX_HAVE_STRDUP 1/w
s/#define BX_NO_ATTRIBUTES 0/#define BX_NO_ATTRIBUTES 1/w
!
! 1.3
!
s/#define BX_HAVE_SLEEP 0/#define BX_HAVE_SLEEP 1/w
s/#define BX_HAVE_USLEEP 0/#define BX_HAVE_USLEEP 1/w
s/#define BX_HAVE_ABORT 0/#define BX_HAVE_ABORT 1/w
!
! This breaks "log: sys$output" which I like, haven't checked the advantages
! s/#define BX_HAVE_GETENV 0/#define BX_HAVE_GETENV 1/w
!
s/#define BX_HAVE_STRUCT_TIMEVAL 0/#define BX_HAVE_STRUCT_TIMEVAL 1/w
!
! -
exit
$!
$return
$!------------------------------------------------------------------------------
$DO_VERSION:
$	msg "Making BXVERSION.H"
$	if f$search("bxversion.h") .nes. ""
$	  then	msg " (exists)"
$		return
$	endif
$	if f$search("[.bin]bxversion.h_tmp") .nes. ""
$	  then	delete/nolog [.bin]bxversion.h_tmp;*
$	endif
$	search configure.; "VER_STRING=","REL_STRING="/exact -
		/out=[.bin]bxversion.h_tmp
$	define/user sys$output nla0:
$	edit/edt/command=sys$input [.bin]bxversion.h_tmp
set tab 8
tab adj 1 w
s/	/#define /w
s/=/ /w
write bxversion.h
quit
$!
$return
$!------------------------------------------------------------------------------
$DO_LINK:
$	msg "Linking"
$	exe_fn = "[.bin]bochs.exe;"
$	if f$search(exe_fn) .nes. ""
$	  then	delete/nolog 'exe_fn'*
$	endif
$	set noon
$	cxxlink 'q_debug'/exe='exe_fn' -
		 [.bin]main.obj -
		,[.bin]cpu.olb/lib -
		,[.bin]fpu.olb/lib -
		,[.bin]gui.olb/lib -
		,[.bin]iodev.olb/lib -
		,[.bin]memory.olb/lib -
		,[.bin]main.olb/lib -
		,sys$library:decwindows.olb/lib
$	link_status = $status
$	set on
$	if f$search(exe_fn) .eqs. ""
$	  then	error_message "LINK: didn't create " + exe_fn
$		goto ERROR_HANDLER
$	  else	msg "Created ", exe_fn
$	endif
$	if f$message(link_status,"SEVERITY") .nes. "%S"
$	  then	msg "WARNING: Link warnings"
$	endif
$return
$!------------------------------------------------------------------------------
$DO_MAIN:
$	comp "" []main.cc		BOOLEXPRCONST
$	comp main []load32bitOShack.cc
$	comp main []state_file.cc
$	comp main []pc_system.cc
$	comp main []osdep.cc
$	comp main []logio.cc
$return
$!------------------------------------------------------------------------------
$DO_FPU:
$	fpu_defines = "USE_WITH_CPU_SIM,NO_ASSEMBLER,PARANOID"
$	def linux [.fpu.stubs.linux]
$	def asm [.fpu.stubs.asm]
$ !
$	comp fpu [.fpu]fpu.cc
$	comp fpu [.fpu]wmfpuemu_glue.cc
$	comp fpu [.fpu]fpu_entry.c
$	comp fpu [.fpu]errors.c
$	comp fpu [.fpu]reg_ld_str.c
$	comp fpu [.fpu]load_store.c
$	comp fpu [.fpu]fpu_arith.c
$	comp fpu [.fpu]fpu_aux.c
$	comp fpu [.fpu]fpu_etc.c
$	comp fpu [.fpu]fpu_tags.c
$	comp fpu [.fpu]fpu_trig.c	QUESTCOMPARE1
$	comp fpu [.fpu]poly_atan.c	UNINIT1
$	comp fpu [.fpu]poly_l2.c
$	comp fpu [.fpu]poly_2xm1.c
$	comp fpu [.fpu]poly_sin.c
$	comp fpu [.fpu]poly_tan.c
$	comp fpu [.fpu]reg_add_sub.c
$	comp fpu [.fpu]reg_compare.c
$	comp fpu [.fpu]reg_constant.c
$	comp fpu [.fpu]reg_convert.c
$	comp fpu [.fpu]reg_divide.c
$	comp fpu [.fpu]reg_mul.c
$	comp fpu [.fpu]reg_u_add.c
$	comp fpu [.fpu]reg_u_div.c
$	comp fpu [.fpu]reg_u_mul.c
$	comp fpu [.fpu]reg_u_sub.c
$	comp fpu [.fpu]div_small.c
$	comp fpu [.fpu]reg_norm.c
$	comp fpu [.fpu]reg_round.c
$	comp fpu [.fpu]wm_shrx.c
$	comp fpu [.fpu]wm_sqrt.c
$	comp fpu [.fpu]div_Xsig.c
$	comp fpu [.fpu]polynom_Xsig.c
$	comp fpu [.fpu]round_Xsig.c
$	comp fpu [.fpu]shr_Xsig.c
$	comp fpu [.fpu]mul_Xsig.c
$ !
$	deass linux
$	deass asm
$return
$!------------------------------------------------------------------------------
$DO_GUI:
$	comp gui [.gui]gui.cc
$	comp gui [.gui]control.cc		INTSIGNCHANGE
$	comp gui [.gui]siminterface.cc
$	comp gui [.gui]x.cc			NOSIMPINT
$return
$!------------------------------------------------------------------------------
$DO_IODEV:
$	comp iodev [.iodev]devices.cc
$	comp iodev [.iodev]pic.cc		CODEUNREACHABLE
$	comp iodev [.iodev]pit.cc
$	comp iodev [.iodev]pit82c54.cc
$	comp iodev [.iodev]pit_wrap.cc
$	comp iodev [.iodev]unmapped.cc
$	comp iodev [.iodev]cmos.cc
$	comp iodev [.iodev]dma.cc
$	comp iodev [.iodev]floppy.cc		CODEUNREACHABLE
$	comp iodev [.iodev]harddrv.cc		CODEUNREACHABLE
$	comp iodev [.iodev]keyboard.cc
$	comp iodev [.iodev]parallel.cc		CODEUNREACHABLE
$	comp iodev [.iodev]serial.cc
$	comp iodev [.iodev]vga.cc		CODEUNREACHABLE,CODCAUUNR
$	comp iodev [.iodev]cdrom_vms.cc
$return
$!------------------------------------------------------------------------------
$DO_MEMORY:
$	comp memory [.memory]memory.cc
$	comp memory [.memory]misc_mem.cc
$return
$!------------------------------------------------------------------------------
$DO_CPU:
$	comp cpu [.cpu]init.cc
$	comp cpu [.cpu]access.cc
$	comp cpu [.cpu]cpu.cc
$	comp cpu [.cpu]resolve32.cc
$	comp cpu [.cpu]fetchdecode.cc		CODEUNREACHABLE
$	comp cpu [.cpu]exception.cc
$	comp cpu [.cpu]ctrl_xfer_pro.cc		CODEUNREACHABLE,CODCAUUNR
$	comp cpu [.cpu]flag_ctrl_pro.cc
$	comp cpu [.cpu]io_pro.cc
$	comp cpu [.cpu]protect_ctrl_pro.cc
$	comp cpu [.cpu]segment_ctrl_pro.cc
$	comp cpu [.cpu]stack_pro.cc
$	comp cpu [.cpu]lazy_flags.cc
$	comp cpu [.cpu]paging.cc
$	comp cpu [.cpu]vm8086.cc
$	comp cpu [.cpu]tasking.cc
$	comp cpu [.cpu]debugstuff.cc
$	comp cpu [.cpu]arith32.cc
$	comp cpu [.cpu]mult32.cc
$	comp cpu [.cpu]data_xfer32.cc
$	comp cpu [.cpu]logical32.cc
$	comp cpu [.cpu]ctrl_xfer32.cc
$	comp cpu [.cpu]stack32.cc
$	comp cpu [.cpu]shift32.cc
$	comp cpu [.cpu]arith8.cc
$	comp cpu [.cpu]mult8.cc
$	comp cpu [.cpu]data_xfer8.cc
$	comp cpu [.cpu]logical8.cc
$	comp cpu [.cpu]ctrl_xfer8.cc
$	comp cpu [.cpu]shift8.cc
$	comp cpu [.cpu]resolve16.cc
$	comp cpu [.cpu]arith16.cc
$	comp cpu [.cpu]mult16.cc
$	comp cpu [.cpu]data_xfer16.cc
$	comp cpu [.cpu]logical16.cc
$	comp cpu [.cpu]ctrl_xfer16.cc
$	comp cpu [.cpu]stack16.cc
$	comp cpu [.cpu]shift16.cc
$	comp cpu [.cpu]bit.cc
$	comp cpu [.cpu]flag_ctrl.cc
$	comp cpu [.cpu]io.cc
$	comp cpu [.cpu]proc_ctrl.cc
$	comp cpu [.cpu]protect_ctrl.cc		CODEUNREACHABLE
$	comp cpu [.cpu]segment_ctrl.cc
$	comp cpu [.cpu]soft_int.cc
$	comp cpu [.cpu]string.cc
$	comp cpu [.cpu]bcd.cc
$return
$!------------------------------------------------------------------------------
$ERROR_HANDLER:
$	error_status = $status
$	set noon
$	if "''error_message'" .eqs. ""
$	  then	error_message = error_status + " " + f$message(error_status)
$	endif
$	write sys$output "ERROR: ", error_message
$	goto END
$!------------------------------------------------------------------------------
$SETUP:
$	if P1 .eqs. ""
$	  then	gosub SHOW_USAGE
$		exit
$	endif
$!
$	msg = "write sys$output f$fao(""!8%T "", 0), "
$!
$	if f$search("bochs.h") .eqs. ""
$	  then	error_message = "Can't find BOCHS.H"
$		goto ERROR_HANDLER
$	endif
$!
$	p_phase = f$edit(P1,"TRIM,UPCASE")
$	p_options = P2 + P3 + P4 + P5 + P6 + P7 + P8
$!
$	if (v_phases - (" " + p_phase + " ")) .eqs. v_phases
$	  then	error_message = "Invalid phase - " + p_phase
$		goto ERROR_HANDLER
$		exit
$	  else	msg "MAKE_VMS (", p_phase, ")"
$	endif
$!
$	if (p_options - "DEB") .nes. p_options
$	  then	msg "/DEBUG qualifier enabled for compile/link"
$		q_debug = "/DEBUG"
$	  else	q_debug = "/NODEBUG"
$	endif
$!
$	define/process/nolog bochs_make_vms_pickup 0
$	if (p_options - "PIC") .nes. p_options
$	  then	if f$trnlnm("bochs_make_vms_phase","LNM$PROCESS_TABLE") -
			.nes. p_phase
$		  then	error_message = "can't PICKUP - different phase"
$			goto ERROR_HANDLER
$		endif
$		if f$trnlnm("bochs_make_vms_task","LNM$PROCESS_TABLE") .eqs. ""
$		  then	error_message = "can't PICKUP - task not set"
$			goto ERROR_HANDLER
$		endif
$		msg "PICKUP enabled"
$		define/process/nolog bochs_make_vms_pickup 1
$	endif
$	define/process/nolog bochs_make_vms_phase 'p_phase'
$!
$	if f$parse("[.bin]a.a") .eqs. ""
$	  then	msg "Creating directory [.bin]"
$		create/dir [.bin]
$	endif
$return
$!------------------------------------------------------------------------------
$SHOW_USAGE:
$	write sys$output "@MAKE_VMS PHASE [OPTIONS]"
$	write sys$output " Phases:  ", v_phases
$	write sys$output " Options: ", v_options
$return
$!------------------------------------------------------------------------------
$COMPILE: subroutine	! P1 = lib, P2 = file, [P3] = warning supression
$ on warning then exit $status
$ on control_y then exit %x2
$!
$	lib = P1
$	fname = P2
$	s_warn = P3
$!
$	if f$trnlnm("bochs_make_vms_pickup","LNM$PROCESS_TABLE")
$	  then	if fname .nes. f$trnlnm("bochs_make_vms_task" -
			,"LNM$PROCESS_TABLE")
$		  then	exit
$		  else	define/process/nolog bochs_make_vms_pickup 0
$		endif
$	endif
$	define/process/nolog bochs_make_vms_task 'fname'
$
$	if f$search(fname) .eqs. ""
$	  then	write sys$error "COMPILE: can't find " + fname
$		exit %x2
$	endif
$
$	if lib .nes. ""
$	  then	lib_fn = "[.bin]" + lib + ".olb"
$		if f$search(lib_fn) .eqs. ""
$		  then	library/create 'lib_fn'
$		endif
$	endif
$
$	ftyp = f$parse(fname,,,"TYPE")
$	command = ""
$	if ftyp .eqs. ".C" then $command = "cc"
$	if ftyp .eqs. ".CC" then $command = "cxx"
$	if command .eqs. ""
$	  then	write sys$eror "COMPILE: don't know what to do with " + ftyp
$		exit %x2
$	endif
$
$	obj_fn = f$parse("[.bin].obj;",fname)
$	if f$search(obj_fn) .nes. ""
$	  then	delete/nolog 'obj_fn'*
$	endif
$
$	if f$type('lib'_defines) .eqs. ""
$	  then	q_define = ""
$	  else	sym = lib + "_defines"
$		q_define = "/define=(" + 'sym' + ")"
$	endif
$	if s_warn .eqs. ""
$	  then	q_warn = ""
$	  else	q_warn = "/warning=(disable=(" + s_warn + "))"
$	endif
$
$	msg "Compiling ", fname, " ", q_warn
$
$	set noon
$	command 'q_debug' /include=('include_dir') 'q_define' 'q_warn' -
		'fname' /obj='obj_fn' 'q_warn'
$	compile_status = $status
$	set on
$ !
$	if f$search(obj_fn) .eqs. ""
$	  then	write sys$error "COMPILE: couldn't make " + fname
$		exit %x2
$	endif
$ !
$	if lib .nes. ""
$	  then	libr/replace 'lib_fn 'obj_fn'
$		delete/nolog 'obj_fn'
$	endif
$!
$endsubroutine
